MOVES  ;MOVES/ASM
 MOVESHIP
 	CALL	SHIPVERT	;vertical adjust?
 	CALL	FIRE		;ship firing ?
 	CALL	REVERSE		;check shift key
 	LD	A,(3840H)	;get arrow keys
 	BIT	5,A		;L arrow?
 	JP	Z,SLOWUP	;slow it up a little
 	LD	A,(WAY)
 	BIT	0,A
 	JR	NZ,LARR
 	JR	C,RBAK		;reverse direction
 	LD	A,(SHIPR)	;get relative posit
 	CP	8		;at left side?
 	JR	NC,RBAKX	;adjust, and slow
 RFGO	LD	A,(SPEED)	;get speed factor
 	INC	A		;bump it
 	CP	12
 	JR	NC,MOVESHP	;at maximum
 	LD	(SPEED),A
 	JR	MOVESHP		;else go faster
 RBAK	XOR	A
 	LD	(WAY),A
 	LD	A,(SHIPR)
 RBAKX	SUB	10		;go left some more
 	CP	7
 	JR	NC,RBAKY
 	LD	A,7
 RBAKY	LD	(SHIPR),A	;put here
 	JR	SLOWUP		;slow it down more
 LARR	JR	C,LBAK		;change direction
 	LD	A,(SHIPR)
 	CP	120		;at right side?
 	JR	NZ,LBAKX	;adjust and slow
 	JR	RFGO		;bump the speed
 LBAK	LD	A,1
 	LD	(WAY),A
 	LD	A,(SHIPR)
 LBAKX	ADD	A,10		;move it right
 	CP	120
 	JR	C,LBAKY		;in bounds
 	LD	A,120
 LBAKY	LD	(SHIPR),A
 	JR	SLOWUP		;slow 'er down
 MOVESHP	LD	A,(SPEED)	;any speed?
 	OR	A
 	RET	Z
 	LD	B,A		;else pass to BC
 	LD	A,(WAY)		;which way?
 	OR	A		;clear carry, and set Z
 	LD	HL,(SHIPH)	;get horizontal posit
 	JR	NZ,MOVESPY
 	LD	A,(SHIPR)	;at end of swing?
 	CP	8
 	JR	NC,MOVESP	;still going backward
 MOVESPX	CALL	FHL
 	DJNZ	MOVESPX
 	LD	(SHIPH),HL
 	RET
 MOVESPY	LD	A,(SHIPR)	;get ship relative
 	CP	120
 	JR	NZ,MOVESPX	;still goin' forward
 MOVESP	CALL	BHL
 	DJNZ	MOVESP
 	LD	(SHIPH),HL
 	RET
 SLOWUP	CALL	SLOWDOWN
 	JR	MOVESHP
 SLOWDOWN	LD	A,(SPEED)
 	OR	A
 	RET	Z
 	DEC	A
 	LD	(SPEED),A
 	RET
 REVERSE	LD	A,(3880H)	;shift pressed?
 	OR	A
 	JR	Z,NOREV		;nope if Z
 REVINT	NOP			;intercept byte
 	LD	A,0C9H		;don't go here next time
 	LD	(REVINT),A
 	LD	A,(WAY)		;reverse direction
 	XOR	1		;toggle bit 0
 	LD	(WAY),A
 	SCF
 	RET
 NOREV	LD	(REVINT),A
 	RET
 SHIPVERT	LD	A,(3840H)	;check up/down
 	BIT	3,A		;up?
 	JR	NZ,SHIPUP
 	BIT	4,A		;down?
 	RET	Z
 	LD	A,(SHIPV)	;get position
 	INC	A		;move down
 	CP	47		;bottom?
 	RET	NC		;no farther
 VERET	LD	(SHIPV),A	;update value
 	RET
 SHIPUP	LD	A,(SHIPV)
 	DEC	A		;move up
 	CP	11		;top?
 	RET	C
 	JR	VERET
 DRAWSHIP	LD	A,(SHIPV)
 	LD	H,A		;vertical position
 	LD	A,(SHIPR)
 	LD	L,A		;horizontal position
 	LD	A,(WAY)		;get direction
 	OR	A		;z = forward
 	JR	NZ,DDRWW		;right facing
 	LD	IX,TABLE2A	;right facing ship
 	LD	BC,TABLE2AA	;right face with thrust
 	JR	DDRWWXX		;continue
 DDRWW	LD	IX,TABLE2B	;left facing ship
 	LD	BC,TABLE2BB	;left with thrust
 DDRWWXX	LD	A,(3840H)	;check for thrust
 	BIT	5,A
 	JR	Z,DRAWIT	;none
 	PUSH	BC
 	POP	IX		;else pass alt value
 DRAWIT	LD	A,(IX)		;get table byte
 	INC	IX		;point to next
 	CP	80H		;terminator?
 	RET	Z		;done
 	ADD	A,H		;add to vertical
 	LD	D,A		;pass here
 	LD	A,(IX)		;get next table byte
 	INC	IX		;point to next one
 	ADD	A,L		;add to horizontal
 	LD	E,A		;pass here
 	PUSH	HL		;save start pointer
 	CALL	SET		;turn on the pixel
 	POP	HL		;restore start pointer
 	JR	DRAWIT		;continue
 DRAWITX	LD	A,(IX)		;get table byte
 	INC	IX		;point to next
 	CP	80H
 	RET	Z
 	ADD	A,H
 	LD	D,A
 	LD	A,(IX)		;get next byte
 	INC	IX
 	ADD	A,L
 	LD	E,A
 	PUSH	HL
 	LD	A,D
 	CP	48
 	JR	NC,SKPTST
 	LD	A,E
 	CP	128
 	JR	NC,SKPTST
 	PUSH	DE
 	CALL	TEST
 	POP	DE
 	LD	A,0
 	JR	NZ,HITIT
 	BIT	7,(HL)
 	LD	A,(HL)
 	JR	Z,HITIT
 	PUSH	DE
 	CALL	SET		;turn it on
 	POP	DE
 SKPTST	POP	HL
 	JR	DRAWITX
 HITIT	PUSH	IY
 	PUSH	IX
 	CALL	HITSOME		;hit something
 	POP	IX
 	POP	IY
 	POP	HL
 	JR	NC,DRAWITX
 	LD	(IY),0
 	RET
 SET	LD	A,0C6H
 	JR	TEST10
 RESET	LD	A,86H
 	JR	TEST10
 TEST	LD	A,46H
 TEST10	LD	(INS+1),A
 	LD	A,D
 	CP	48
 	RET	NC
 	LD	A,E
 	CP	128
 	RET	NC
 ADDRES	LD	A,D		;get Y
 	LD	B,-1
 ADLP	INC	B
 	SUB	3
 	JP	P,ADLP
 	ADD	A,3
 	SLA	A
 	LD	C,A
 	LD	L,B
 	LD	H,0
 	LD	B,6
 ADLP1	ADD	HL,HL
 	DJNZ	ADLP1
 	LD	D,0
 	SRL	E
 	JR	NC,ADCONT
 	INC	C
 ADCONT	ADD	HL,DE
 	LD	DE,OLAY		;use overlay area
 	ADD	HL,DE
 	SLA	C
 	SLA	C
 	SLA	C
 	LD	A,(INS+1)
 	ADD	A,C
 	LD	(INS+1),A
 INS	DB	0CBH
 	DB	0
 	RET
 FIRE	LD	A,(3840H)	;R arrow ?
 	BIT	6,A
 	JR	Z,FIRENO	;allow loop
 FIRINT	NOP
 	LD	A,0C9H
 	LD	(FIRINT),A
 	LD	B,20
 	LD	HL,TABLEF	;firing table
 FIRLP	LD	A,(HL)		;available ?
 	OR	A
 	JR	Z,PUTFIR	;yep if Z
 	INC	HL		;else bump x 3
 	INC	HL
 	INC	HL
 	DJNZ	FIRLP		;continue
 	RET			;no more slots
 FIRENO	XOR	A
 	LD	(FIRINT),A	;allow next pass
 	RET
 PUTFIR	LD	(HL),1		;first stage
 	LD	A,(WAY)		;get direction
 	OR	A
 	LD	A,(SHIPR)
 	JR	Z,PUTFIRX	;forward
 	LD	(HL),6		;set backward
 	SUB	10
 	JR	FIRCOM
 PUTFIRX	ADD	A,10
 FIRCOM	INC	HL
 	EX	AF,AF'
 	LD	A,(SHIPV)
 	LD	(HL),A
 	INC	HL
 	EX	AF,AF'
 	LD	(HL),A
 	RET			;table all set
 SSHOTS	LD	IY,TABLEF	;firing table
 	LD	B,20		;20 entries possible
 SSHOTLP	LD	A,(IY)		;active entry?
 	OR	A
 	JR	NZ,SSHOT	;shoot it
 SHOTCONT	INC	IY
 	INC	IY
 	INC	IY
 	DJNZ	SSHOTLP		;do 'em all
 	RET			;all 20 done
 SSHOT	LD	C,A		;save stage here
 	PUSH	BC		;save counter
 	LD	B,0
 	DEC	C
 	SLA	C		;decrement and double
 	LD	HL,TABLE3	;for table lookup
 	ADD	HL,BC		;point to entry
 	LD	E,(HL)		;get lsb table
 	INC	HL
 	LD	D,(HL)		;get msb table
 	PUSH	DE
 	POP	IX		;IX => type table
 	LD	H,(IY+1)	;get vertical
 	LD	L,(IY+2)	;get horozontal
 	CALL	DRAWITX		;draw the shot
 	POP	BC
 	LD	A,(IY)		;bump shot type
 	OR	A
 	JR	Z,SHOTCONT
 	CP	6		;backwards?
 	JR	NC,SHOTBAK
 	INC	A
 	LD	(IY),A
 	CP	6
 	JR	C,SHOTCONT
 SHOTDEAD	LD	(IY),0
 	JR	SHOTCONT
 SHOTBAK	INC	A
 	LD	(IY),A
 	CP	11
 	JR	C,SHOTCONT
 	JR	SHOTDEAD	;de-activate it
 HITSOME	CP	'A'
 	JP	Z,HITAMAN	;hit own man
 	XOR	A
 	LD	(FLAGSAVE),A
 	LD	IY,TABLEC	;creature table
 	LD	B,50		;50 entries
 HITSLP	LD	A,(IY)		;active ?
 	OR	A
 	PUSH	BC
 	CALL	NZ,THISONE	;this one?
 	LD	BC,9
 	ADD	IY,BC
 	POP	BC
 	DJNZ	HITSLP
 	LD	HL,(FLAGSAVE)
 	PUSH	HL
 	POP	AF
 	RET			;can't find it
 THISONE	LD	L,(IY+7)
 	LD	H,(IY+8)
 	LD	A,H
 	OR	L
 	RET	Z
 	OR	A
 	SBC	HL,DE		;this guy?
 	RET	NZ
 	PUSH	IY
 	PUSH	DE
 	CALL	SCOREIT
 	POP	DE
 	POP	IY
 	LD	A,1
 	LD	(FLAGSAVE),A
 	LD	(IY),12
 	LD	(IY+4),0
 	LD	(IY+5),0
 	LD	(IY+6),1	;slow blow
 	RET			;done
 HITAMAN	LD	IX,TABLEC	;find spot
 	LD	B,50		;50 slots
 HITAMLP	LD	A,(IX)		;get a byte
 	OR	A
 	JR	Z,PUTMHIT	;put explosion
 	PUSH	BC
 	LD	BC,9
 	ADD	IX,BC
 	POP	BC
 	DJNZ	HITAMLP
 	JR	KILLMAN		;no more space for it
 PUTMHIT	LD	(IX),12		;turn on a hit
 	LD	(IX+1),D
 	LD	C,E
 	LD	B,0
 	LD	HL,(SHIPH)
 	ADD	HL,BC
 	LD	(IX+2),L
 	LD	(IX+3),H
 	LD	(IX+4),0
 	LD	(IX+5),0
 	LD	(IX+8),1
 	SCF
 KILLMAN	LD	IX,TABLEM	;men table
 	LD	B,10		;10 max
 KILLMLP	LD	A,(IX)		;get a byte
 	OR	A
 	CALL	NZ,TSTMAN	;this one?
 	INC	IX
 	INC	IX
 	INC	IX
 	INC	IX
 	DJNZ	KILLMLP
 	SCF
 	RET
 TSTMAN	PUSH	DE
 	LD	DE,(SHIPH)
 	LD	L,(IX+1)
 	LD	H,(IX+2)
 	OR	A
 	SBC	HL,DE
 	POP	DE
 	RET	C
 	DEC	H
 	INC	H
 	RET	NZ
 	LD	A,L
 	CP	128
 	RET	NC
 	PUSH	DE
 	LD	E,L
 	LD	D,(IX+3)
 	CALL	TEST
 	POP	DE
 	OR	A
 	SBC	HL,DE
 	RET	NZ
 	LD	(IX),0
 	RET
 	POP	DE
 	RET	C
 	DEC	H
 	INC	H
 	RET	NZ
 	LD	A,L
 	CP	128
 	RET	NC
 	PUSH	DE
 	LD	E,L
 	LD	D,(IX+3)
 	CALL	TEST
 	POP	DE
 	OR	A
 	SBC	HL,DE
 	RET	NZ
 	LD	(IX),0